import processing.core.*; import processing.serial.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class clock_analog extends PApplet {
Serial port; // Create object from Serial class

int rintocchi = 0;

public void setup()
{
  size(200,200);    //canvas size
  frameRate(1);    // 1 frame per second.
  println(Serial.list());
  port = new Serial(this, Serial.list()[0], 300);
  port.write(" ");
}

public void draw (){
  background(0);  // clear (black) background
  translate(100,100);  // move origin of axis to the middle of canvas
  rotate(-PI/2);      // rotate axis so that 0 deg. is noon.
  fill(80);            // fill color is gray
  smooth();            // antialias
  ellipse(0, 0, 200, 200);
  stroke(200);
  for(int i = 0; i < 12; i++){
    line(0, 95, 0, 100);
    rotate(PI/6);
  }
  fill(150);            // fill with lighter gray.
  float s = 6*second()*PI/180;  // position of seconds hand (in radians)
  float m = 6*minute()*PI/180;  // minutes
  float h = (30*hour()+minute()/2)*PI/180;  // hours
  rotate(h);          // rotate the difference between mins and hours
  quad(0, 0, 40, -5, 70, 0, 40, 5);
  rotate(m-h);          // rotate the difference between secs and mins
  quad(0, 0, 70, -5, 90, 0, 70, 5);
  rotate(s-m);            // rotate axis then draw seconds hand
  quad(0, 0, 70, -3, 90, 0, 70, 3);
  ellipse(0, 0, 10, 10);
  fill(0);            // fill with lighter black
  noStroke();
  ellipse(0, 0, 2, 2);
  if ((second() == 0) && (minute() == 0)){  // at beginning of hours
    rintocchi = hour();    // set number of strikes to do
    if (rintocchi == 0) rintocchi = 12;  // correct for midnight
    if (rintocchi > 12) rintocchi -= 12;  // correct for 24 hours
  }
  if (rintocchi > 0){    // do strike
    port.write(" ");
    rintocchi--;        // strikes - 1
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "clock_analog" });  }}